SystemOrganization addCategory: #'A4BP-SimEngine-View'!
SystemOrganization addCategory: 'A4BP-SimEngine-View-Observers'!
SystemOrganization addCategory: 'A4BP-SimEngine-View-UI'!

A4BPUIGLMActionTreeBuilderVisitor subclass: #BPSimUINavigatorFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUINavigatorFactory class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:55'!
buildNavigator: aModel
	aModel ifNil: [ ^ BPSimUIDoNothingNavigator new ].
	^ aModel accept: self new! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:45'!
doNothing: aModel
	^ BPSimUIDoNothingNavigator new! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:33'!
visitBPSimBPMN20ExecutionVisitor: aModel
	^ self visitBPSimExecutionVisitor: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:47'!
visitBPSimEngineController: aModel
		^ self doNothing: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:47'!
visitBPSimEngineProcess: aModel
	^ self doNothing: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/2/2015 18:57'!
visitBPSimEngineScenario: aModel
	^ BPSimUIEngineScenarioNavigator new bpSimEngineScenario: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:41'!
visitBPSimEngineSimulations: aModel
	^ BPSimUISimulationsNavigator new bpSimSimulations: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:05'!
visitBPSimExecutionVisitor: aModel
	^ BPSimUIExecutionNavigator new bpSimExecution: aModel! !

!BPSimUINavigatorFactory methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:47'!
visitBPSimScenario: aModel
	^ self doNothing: aModel! !

A4BPUIGLMActionTreeBuilderVisitor subclass: #BPSimUIRClickVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 13:57'!
actionBasicBrowser: aBPObject
	^ OrderedCollection new! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 13:54'!
extendActions: actions In: aModel
	actions addAll: (aModel accept:self).! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 13:55'!
visitA4BPObject: aModel
	^ OrderedCollection new! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 09:14'!
visitBPMN20DefinitionsImpl: aModel
	| actions act|
	actions:= OrderedCollection new.
	"Create Process Simulation"
	act:=GLMGenericAction new 
	action:[ :b | 
		BPSimEngineController instance createEngineProcess: aModel.
		mainBrowser update.
		b update.
		];
	category: A4BPUII18n msg msgBPSim;
	title: A4BPUII18n msg msgCreateSimulation.
	actions add:act.
	
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 17:17'!
visitBPSimBPMN20ExecutionVisitor: aModel
	| actions |
	actions := super actionBasicBrowser: aModel.
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:04'!
visitBPSimEngineController: aModel
	| actions |
	actions := super actionBasicBrowser: aModel.
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 09:15'!
visitBPSimEngineProcess: aModel
	| actions act|
	actions := super actionBasicBrowser: aModel.
	
	"Create new scenario"
	act:=GLMGenericAction new 
	action:[ :b | 
		aModel createEngineScenario.
		b update.
		];
	category: A4BPUII18n msg msgBPSim;
	title: A4BPUII18n msg msgCreateScenario.
	actions add:act.
	
	"Create new simulation"
	act:=GLMGenericAction new 
	action:[ :b | 
		aModel createEngineSimulation.
		b update.
		];
	category: A4BPUII18n msg msgBPSim;
	title: A4BPUII18n msg msgCreateSimulation.
	actions add:act.
	
	"Delete"
	act:=GLMGenericAction new 
	action:[ :b | 
		aModel engineController deleteEngineProcess: aModel.
		b update.
		mainBrowser update.
		];
	category: A4BPUII18n msg msgBPSim;
	title: A4BPUII18n msg msgDelete.
	actions add:act.
	
	
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 09:15'!
visitBPSimEngineScenario: aModel
	| actions act|
	actions := super actionBasicBrowser: aModel.
	
	"Create Simulation"
	act:=GLMGenericAction new 
	action:[ :b | 
		aModel createSimulation.
		b update.
		];
	category: A4BPUII18n msg msgBPSim;
	title: A4BPUII18n msg msgCreateSimulation.
	actions add:act.
	
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 16:10'!
visitBPSimEngineSimulations: aModel
	| actions |
	actions := super actionBasicBrowser: aModel.
	^ actions! !

!BPSimUIRClickVisitor methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 15:25'!
visitBPSimScenario: aModel
	| actions |
	actions := super actionBasicBrowser: aModel.
	^ actions! !

!A4BPUIMainModel methodsFor: '*A4BP-SimEngine-View-UI' stamp: 'AlvaroJosePeraltaOcamop 3/30/2015 23:40'!
displayBPSimElements
	^ BPSimEngineController instance! !

!A4BPUII18n_en methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:01'!
msgBPSim
	^ 'Simulation'! !

!A4BPUII18n_en methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:29'!
msgCreateScenario
	^ 'Create Scenario'! !

!A4BPUII18n_en methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:41'!
msgCreateSimulation
	^ 'Create Simulation'! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:20'!
visitBPSimBPMN20EngineProcess: anModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 17:17'!
visitBPSimBPMN20ExecutionVisitor: aModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcamop 3/30/2015 23:47'!
visitBPSimEngineController: anModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:22'!
visitBPSimEngineProcess: anModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 15:23'!
visitBPSimEngineScenario: anModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 15:55'!
visitBPSimEngineSimulations: anModel
	^ Smalltalk ui icons processBrowserIcon! !

!A4BPUIBPModelIconBuilderVisitor methodsFor: '*A4BP-SimEngine-View' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:37'!
visitBPSimScenario: anModel
	^ Smalltalk ui icons processBrowserIcon! !

A4BPUIGLMBuilder subclass: #BPSimUIAbstractNavigator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUIAbstractNavigator methodsFor: 'navigator' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:48'!
displayBoardIn: constructor 
	^ constructor! !

!BPSimUIAbstractNavigator methodsFor: 'navigator' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:03'!
displayResultsIn: constructor
	^ constructor! !

BPSimUIAbstractNavigator subclass: #BPSimUIDoNothingNavigator
	instanceVariableNames: 'bpSimSimulations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

BPSimUIAbstractNavigator subclass: #BPSimUIEngineScenarioNavigator
	instanceVariableNames: 'bpSimEngineScenario simb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/2/2015 18:55'!
bpSimEngineScenario
	^ bpSimEngineScenario! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/2/2015 18:55'!
bpSimEngineScenario: anObject
	bpSimEngineScenario := anObject! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/2/2015 22:28'!
createSimBuilder
	simb := BPSimBuilder new 
	addCurrentScenario: bpSimEngineScenario scenario;
	processModel: bpSimEngineScenario processModel.
	^ simb
! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/17/2015 16:08'!
defaultScriptBindings
	| col bpsim|
	bpsim := self createSimBuilder.
	col := OrderedCollection withAll: {#model -> bpSimEngineScenario }.
	col addAll: {#simb -> bpsim}.
	^ col 
 ! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 16:45'!
defaultScriptDisplayIn: p
	^ p 
		display: (self displayCode);
		morphicAct: [ :code :engineScenario | 
			code transformation: (self generateExampleCode: engineScenario).
			code update.
		]
		icon: GLMUIThemeExtraIcons glamorousExample
		entitled: 'Generate Example code'! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/3/2015 19:39'!
displayBoardIn: glmc
	| tab |
	tab := glmc tabulator.
	tab
		column: #CodeBuilder;
		column: #BPSimResultTable.
		
	tab transmit
		to: #CodeBuilder;
		andShow: [ :a | self displayCodeBuilderIn:a].
	tab transmit
		to: #BPSimResultTable;
		from: #CodeBuilder;
		andShow: [ :a :script| 
			|context|
			context := GLMDoItContext withAll: self defaultScriptBindings.
			self evaluate: script in: context.
			self displayScenarioIn:a ].! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 17:00'!
displayCode
	bpSimEngineScenario codeBuilderImpl ifNil:[ 
		bpSimEngineScenario codeBuilderImpl: (self generateExampleCode: bpSimEngineScenario).
	].
	^ bpSimEngineScenario codeBuilderImpl
	
! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/2/2015 22:17'!
displayCodeBuilderIn:a
	a smalltalkCode
			title: 'Script';
			variableBindings: [ :engineScenario | self defaultScriptBindings];
			with: [:p | self defaultScriptDisplayIn: p ];
			populate: #selection
				icon: GLMUIThemeExtraIcons glamorousPlay
				on: $s
				entitled: 'Generate'
				with: [ :text | text text ]! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 15:01'!
displayScenarioIn: a
	|scenario|
	scenario := simb currentScenario.
	bpSimEngineScenario scenario:simb currentScenario.
	a 
	act: [ :b | b update ] 
	icon: GLMUIThemeExtraIcons glamorousRefresh 
	entitled: A4BPUII18n msg msgOpenNewSOAContext.
	
	BPSimUIGLMTblScenario displayIn: a usingScenario: scenario.! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 16:59'!
evaluate: script in: context
	^ [ 
		|result|	
		result := (Smalltalk compiler requestor: self) evaluate: script in: context to: context.
		bpSimEngineScenario codeBuilderImpl:script.
		result.
		]
		on: Error
		do: [ :e | ^ self createSimBuilder]! !

!BPSimUIEngineScenarioNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/17/2015 16:38'!
generateExampleCode: engineScenario
	"must be return a string value"
	|ws model|
	ws := String new writeStream.
	model := engineScenario processModel.
	model flowElements do:[ :el |
		|name|
		name := el aName.
		'' = name
			ifFalse:[ 
				|regexName|
				regexName := name copyWithRegex: '['']' matchesReplacedWith:''''''.
				ws nextPutAll:
				'simb timer name: ''',regexName,''';',
				"add processing time"
				'p: (simb triangular min:1;mode:50;max:100).';cr.
				 ws nextPutAll:
				'simb resource name: ''',regexName,''';',
				"add resource quantity"
				'q: (simb triangular min:1;mode:5;max:10).'; cr 
				]. 
	].
	^ ws contents
	
	! !

!BPSimUIEngineScenarioNavigator methodsFor: 'intialization' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 16:56'!
initialize
	super initialize.
! !

BPSimUIAbstractNavigator subclass: #BPSimUIExecutionNavigator
	instanceVariableNames: 'bpSimExecution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUIExecutionNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:00'!
bpSimExecution
	^ bpSimExecution! !

!BPSimUIExecutionNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:00'!
bpSimExecution: anObject
	bpSimExecution := anObject! !

!BPSimUIExecutionNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/3/2015 19:33'!
displayResultsIn: glmc
	| tab |
	tab := glmc tabulator.
	tab
		column: #RTViz;
		column: #BPSimResultTable.
	tab transmit
		to: #RTViz;
		andShow: [ :a | 
					a roassal2
						painting: [ :view :viewBuilder | 
									"For all visualization can be draggable"
									view @ RTDraggableView.
									self executeVisualization: view ];
						title: A4BPUII18n msg msgVisualization ].
	tab transmit
		to: #BPSimResultTable;
		andShow: [ :a | 
			a act: [ :b |  b update ]
			icon: GLMUIThemeExtraIcons glamorousRefresh
			entitled: A4BPUII18n msg msgOpenNewSOAContext.
			a accordionArrangement.
			self displayScenarioIn:a
		].! !

!BPSimUIExecutionNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/17/2015 15:58'!
displayScenarioIn: a
	|scenario|
	scenario := bpSimExecution outputScenario.
	"tobserver := BPSimGLMTableObserver new.
	table := a table.
	tobserver table:table.
   bpSimExecution addObserver: tobserver."
	BPSimUIGLMTblScenario displayIn: a usingScenario: scenario.
	! !

!BPSimUIExecutionNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 15:19'!
executeVisualization: view
	bpSimExecution rtObserver makeView: view.! !

BPSimUIAbstractNavigator subclass: #BPSimUINavigator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUINavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 13:17'!
buildBrowserIn: browser
	| tab |
	mainBrowser := browser.
	tab := browser tabulator.
	tab title:'Simulation'.
	tab
		column: #BPSimPerspective;
		column: #BPSimBoard span: 5.	"set what information must be to show"
	tab transmit
		to: #BPSimPerspective;
		andShow: [ :a | self displayTreeNodesIn: a ].
	tab transmit
		to: #BPSimBoard;
		from: #BPSimPerspective;
		andShow: [ :a :model | self displayBoardIn: a baseOn: model].
	^ browser! !

!BPSimUINavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:18'!
childrenOf: rootPackage on: organizer
	rootPackage ifNotNil: [  ^ rootPackage getChildrenNodes ].
	^ A4BPEmptyObj instance getChildrenNodes! !

!BPSimUINavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:44'!
displayBoardIn: constructor baseOn: aModel
	|navigator|
	navigator := BPSimUINavigatorFactory buildNavigator: aModel .
	navigator displayBoardIn:constructor.
	^ constructor! !

!BPSimUINavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/30/2015 16:19'!
displayIn: constructor
	| actiontreev |
	"build the list of options base on the selected element"
	actiontreev := A4BPUIGLMActionTreeBuilderVisitor new.
	constructor tree
		title: A4BPUII18n msg msgSOAModels;
		display: [ :org | org ];
		children: [ :rootPackage :org | self childrenOf: rootPackage on: org ];
		icon: [ :el |  el accept: A4BPUIBVFactory iconVisitor ];
		dynamicActionsOnSelection: [ :list | list selection accept: actiontreev ];
		format: #label.! !

!BPSimUINavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 16:48'!
displayTreeNodesIn: constructor
	| actiontreev |
	"build the list of options base on the selected element"
	actiontreev := BPSimUIRClickVisitor new.
	actiontreev mainBrowser: mainBrowser .
	constructor tree
		title: A4BPUII18n msg msgModels;
		display: [ :org | org displayBPSimElements];
		children: [ :rootPackage :org | self childrenOf: rootPackage on: org ];
		icon: [ :el |  el accept: A4BPUIBVFactory iconVisitor ];
		"Refresh Menu"
		act: [ :b |  b update ]
		icon: GLMUIThemeExtraIcons glamorousRefresh
		entitled: A4BPUII18n msg msgOpenNewSOAContext;
		dynamicActionsOnSelection: [ :list | 
			list selection accept: actiontreev.];
		format: #label.
	^ constructor! !

BPSimUIAbstractNavigator subclass: #BPSimUISimulationsNavigator
	instanceVariableNames: 'bpSimSimulations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUISimulationsNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:41'!
bpSimSimulations
	^ bpSimSimulations! !

!BPSimUISimulationsNavigator methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 14:41'!
bpSimSimulations: anObject
	bpSimSimulations := anObject! !

!BPSimUISimulationsNavigator methodsFor: 'navigator' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 13:16'!
displayBoardIn: constructor 
	| actiontreev tab |
	"build the list of options base on the selected element"
	actiontreev := BPSimUIRClickVisitor new.
	actiontreev mainBrowser: mainBrowser .

	tab := constructor tabulator.
	tab column: #ExecutionBrowser;
		column: #SimulationExplorer span: 5.	"set what information must be to show"

	tab transmit
		to: #ExecutionBrowser;
		andShow: [ :a | 
			a tree
			title: 'Executions';
			display: [ :model | 
				|lst|
				lst := OrderedCollection new.
				lst add: model.
				lst addAll: model getChildrenNodes.
				lst
				];
			act: [:glmc :model | model runSimulation] entitled: 'Play';
			act: [:glmc :model | model stopSimulation ] entitled: 'Stop'.
		].
	tab transmit
		to: #SimulationExplorer;
		from:#ExecutionBrowser;
		andShow: [ :a :b| 
			(a isNotNil and: b isNotNil ) ifTrue:[
				self displayResultsIn: a withModel: b]
			].
	
	^ constructor! !

!BPSimUISimulationsNavigator methodsFor: 'navigator' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 16:26'!
displayResultsIn: a withModel: aModel
	|navigator|
	navigator := BPSimUINavigatorFactory buildNavigator: aModel.
	navigator displayResultsIn: a.
	^ a! !

BPSimUIAbstractNavigator subclass: #BPSimUISimulationsResultNavigator
	instanceVariableNames: 'bpSimSimulations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!A4BPUII18n methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:00'!
msgBPSim
	^ self defaultmsg! !

!A4BPUII18n methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:29'!
msgCreateScenario
	^ self defaultmsg! !

!A4BPUII18n methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:40'!
msgCreateSimulation
	^ self defaultmsg! !

!A4BPUII18n_es methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:01'!
msgBPSim
	^ 'Simulacion'! !

!A4BPUII18n_es methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:29'!
msgCreateScenario
	^ 'Crear Scenario'! !

!A4BPUII18n_es methodsFor: '*A4BP-SimEngine-View-I18n' stamp: 'AlvaroJosePeraltaOcampo 3/31/2015 14:02'!
msgCreateSimulation
	^ 'Crear Simulacion'! !

Object subclass: #BPSimGLMTableObserver
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-Observers'!

!BPSimGLMTableObserver methodsFor: 'view' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 16:40'!
notify: e
	self update.! !

!BPSimGLMTableObserver methodsFor: 'view' stamp: 'AlvaroJosePeraltaOcampo 4/1/2015 16:40'!
open
	"[self view open ] forkAt: Processor userBackgroundPriority"! !

!BPSimGLMTableObserver methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 20:35'!
table
	^ table! !

!BPSimGLMTableObserver methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 20:35'!
table: anObject
	table := anObject! !

!BPSimGLMTableObserver methodsFor: 'view' stamp: 'AlvaroJosePeraltaOcampo 4/15/2015 20:37'!
update
	table update! !

Object subclass: #BPSimUIGLMTblScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-SimEngine-View-UI'!

!BPSimUIGLMTblScenario commentStamp: 'AlvaroJosePeraltaOcampo 4/17/2015 15:52' prior: 0!
A BPSimUIGLMTblScenario is static code to print the result
in tables base on bpsim model.
!

!BPSimUIGLMTblScenario class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 13:49'!
displayIn: a usingScenario: scenario
	|eps table|
	eps := scenario elementParameters select:[ :e | e elementRef aName size > 0 ].
	"tobserver := BPSimGLMTableObserver new.
	table := a table.
	tobserver table:table.
   bpSimExecution addObserver: tobserver."
	a accordionArrangement.
	table := a table.
	table
		title: 'Time Parameters';
		shouldValidate:true;
		act: [ :b "Refresh Menu" | b update ]
			icon: GLMUIThemeExtraIcons glamorousRefresh
			entitled: A4BPUII18n msg msgOpenNewSOAContext;
		display: [ eps];
		column: 'Element' evaluated: [ :each | each elementRef aName ];
		column: 'Processing' evaluated: [ :each | each processing vv asString ];
		column: 'Historical' evaluated: [ :each | each historical vv asString ];
		column: 'ValidationTime' evaluated: [ :each | each validation vv asString ];
		column: 'QueueTime' evaluated: [ :each | each queue vv asString ];
		column: 'TransferTime' evaluated: [ :each | each transfer vv asString ];
		column: 'WaitTime' evaluated: [ :each | each wait vv asString ];
		column: 'EeworkTime' evaluated: [ :each | each rework vv asString ];
		column: 'SetUpTime' evaluated: [ :each | each setUp vv asString ].
	table := a table.	
	table
		title: 'Resources Parameters';
		shouldValidate:true;
		act: [ :b "Refresh Menu" | b update ]
			icon: GLMUIThemeExtraIcons glamorousRefresh
			entitled: A4BPUII18n msg msgOpenNewSOAContext;
		display: [ eps ];
		column: 'Element' evaluated: [ :each | each elementRef aName ];
		column: 'Quantity' evaluated: [ :each | each quantity vv asString ];
		column: 'Availability' evaluated: [ :each | each availability vv asString ].
	
	table := a table.	
	table
		title: 'Cost Parameters';
		shouldValidate:true;
		act: [ :b "Refresh Menu" | b update ]
			icon: GLMUIThemeExtraIcons glamorousRefresh
			entitled: A4BPUII18n msg msgOpenNewSOAContext;
		display: [ eps ];
		column: 'Element' evaluated: [ :each | each elementRef aName ];
		column: 'UnitCost' evaluated: [ :each | each unitCost vv asString ].
		
	table := a table.	
	table
		title: 'Control Parameters';
		shouldValidate:true;
		act: [ :b "Refresh Menu" | b update ]
			icon: GLMUIThemeExtraIcons glamorousRefresh
			entitled: A4BPUII18n msg msgOpenNewSOAContext;
		display: [ eps ];
		column: 'Element' evaluated: [ :each | each elementRef aName ];
		column: 'probability' evaluated: [ :each | each probability vv asString ].! !
